;
; This file provides a few initializations for Scheme-to-C compatibility
;

(define sys$$eval eval)
(define sys$$exit exit)
(define require foo$$require)
(define provide foo$$provide)
(define (sys$$file-exists? x) (file-exists? x))
(define add-load-path foo$$add-load-path)
(define load foo$$load)

(define-macro define-macro%
  (lambda (form expander)
    (let* ((def (cadr form))
	   (body (cddr form))
	   (name (car def))
	   (formals (cdr def)))
    (expander
       `(define-macro ,name
	  (let ((macroexpander (lambda ,formals ,@body)))
	    (lambda (form expander)
	      (expander (apply macroexpander (cdr form)) expander))))))))
