;;;
;;; s t r u c t . s c m		     --	poor man's structures
;;;

;; All objects are meant to be read-only, but for explicit references
;;
;; We trust the program not to modify anything but this emulated type...


(provide 'pmstruct)
(require 'lib)
(require 'types)
(require 'envobj)
(require 'tags)
(require 'ref)


(define (formals->args formals) formals)

(define (add-struct-definitions! env pattern)
  (let* ((symbol 	(car pattern))
	 (formals 	(cdr pattern))
	 (args		(formals->args formals))
	 (tag-name    	(make-symbol symbol "-tag"))
	 (detector-name	(make-symbol symbol "?"))
	 (maker-name	(make-symbol "make-" symbol))
	 (tag		(make-tag symbol))
	 (detector	(vectree-detector tag (length args)))
	 (maker		(vectree-maker tag))
	 (index		(make-ref 1))
	 (make-getter	(lambda ()
			  (v-field-getter (ref:post-inc index)))))
    (env:add-definition! env tag-name tag)
    (env:add-definition! env maker-name maker)
    (env:add-definition! env detector-name detector)
    (for-each (lambda (field)
		(env:add-definition! env (make-symbol symbol "->" field)
				(make-getter)))
	      formals)))
